
//[]{------------------------------------------------------------------------
//AVR   α׷ Ʋ  ϰ Ͻ < ũ>   <ǻ>   ̰ 
//Ƿ ̸ Ͽ ⼭ Ʋ Լ  ´.
//,  AVR  Ϲ   ִ ̴.
//  ش ü  Ͽ óѴ.
//}-----------------------------------------------------------------------------

#include "Լ.h"

#include "AVR.h"

#include "Library\ð.h"


//[]
//{
    //AVR Լ     .
    struct  AVR_INFO  _AVR;    
    
    //AVR  ȥ Ҿ SPI Ʈ.
    unsigned char  _ispƮ[10];

//}

void SPIƮ_ġ(unsigned char **rSPIƮġ)
{
  //[2009.12.04.][!!!]{----
  //SPI Ʈ  ġ Ѱش.
  //}--------------------------
  
  (*rSPIƮġ) = _ispƮ;

}

//-----------------------------------------------------------------------------
//[AVR_ ]----------------------------------------------------------------
//-----------------------------------------------------------------------------

void AVR_ġ(struct  AVR_INFO  **pAVR)
{
  //[2009.12.02.][!!!]{----
  //AVR ü ġ ȯѴ.
  //}--------------------------

  (*pAVR) = &_AVR;
  
}

void AVRINFO_ATmega88_(void)
{
  //[2009.12.01.ȭ][!!!]{--------------------
  //ATmega88(20Mhz)  ° [ü]  Ѵ.
  //}------------------------------------------
  
  //[Flash ]
  //{
      //Flash  ũ(Ʈ ).
      _AVR.flashPageSize = 64;
  
      //Flash ũ(Ʈ ).
      _AVR.flashSize     = 8192;  
  
      //[ / ּ Ȯ]
      //{
          //  ּ.
          _AVR.flashWriteStartAdr = 0;
  
          //  ּ.
          _AVR.flashWriteEndAdr   = (_AVR.flashSize / 2) - 1;
      
      //}    

      //Flash Page  ð(5ms).
      _AVR.flashPageWriteTime = 5;
      
  //}    

  //[EEprom ]
  //{
      //EEprom  ũ(Ʈ ).
      _AVR.eepSize = 512;

      //[ / ּ Ȯ]
      //{
          //  ּ.
          _AVR.eepWriteStartAdr = 0;

          //  ּ.
          _AVR.eepWriteEndAdr   = _AVR.eepSize - 1;
          
      //}

      //EEprom  ð(4ms).
      _AVR.eepWriteTime = 4;

  //}

  //[SignatureByte]
  //{
      //AVR  ϴ  ȣ.
      _AVR.signatureByte[0] = 0x1e;
      _AVR.signatureByte[1] = 0x93;
      _AVR.signatureByte[2] = 0x0a;

  //}

  //[Fuse/Lock]
  //{
      //[!]{--------------------------------------------------
      // bit  ش  ǹϸ <0 : >, <1 : >  ȴ.
      //   ݵ 1    ־ Ѵ.
      //}-----------------------------------------------------
      
      //lock .
      _AVR.lockBit  = 0b11111100;
      
      //fuse  byte .
      _AVR.fuseHigh = 0b11011101;  
      
      //fuse  byte .
      _AVR.fuseLow  = 0b11000000;   
      
      //fuse Ȯ尪(ֱ AVR  Ѵ).
      _AVR.fuseExt  = 0b11111001;   
  
      /*
      <ȼ> : 0b11111100 
      7 - -       1
      6 - -       1 
      5 BLB12 -      1
      4 BLB11 -      1
      3 BLB02 -      1
      2 BLB01 -      1
      1 LB2 *        0 
      0 LB1 *        0
 
      <Ȯ弳> : 0b11111001
      7 - -       1
      6 - -       1
      5 - -       1 
      4 - -       1
      3 - -       1
      2 BOOTSZ1 *    0
      1 BOOTSZ0 *    0
      0 BOOTRST -    1

      <> : 0b11011101
      7 RSTDISBL -   1 
      6 DWEN -       1 
      5 SPIEN *   0 
      4 WDTON -      1
      3 EESAVE -     1
      2 BODLEVEL2 -  1
      1 BODLEVEL1 *  0
      0 BODLEVEL0 -  1

      <> : 0b11000000
      7 CKDIV8 -     1
      6 CKOUT -      1
      5 SUT1 *       0
      4 SUT0 *       0
      3 CKSEL3 *     0
      2 CKSEL2 *     0
      1 CKSEL1 *     0
      0 CKSEL0 *     0
      */

  //}

}

void AVR_Flash_(void)
{
  //[2009.12.02.][!!!]{-----------------------
  //  Flash Ҹ 0xffff   ش.
  //}----------------------------------------------

  //[VAR]
  //{
      unsigned int   i;

  //}

  //[ ]
  //{
      //0xffff   ش.
      
      for(i = 0; i < (_AVR.flashSize / 2); i++)
      {
        _AVR.flashBuf[i] = 0xffff;

      }

  //}

  //[ȿ ּ  ʱȭ]
  //{
      _AVR.flashWriteStartAdr = 0;
      
      _AVR.flashWriteEndAdr   = (_AVR.flashSize / 2) - 1;

  //}

  return;

}

void AVR_EEprom_(void)
{
  //[2009.12.02.][!!!]{------------------------
  //  EEprom Ҹ 0xffff   ش.
  //}-----------------------------------------------

  //[VAR]
  //{
      unsigned int   i;

  //}

  //[ ]
  //{
      //0xff   ش.

      for(i = 0; i < _AVR.eepSize; i++)
      {
        _AVR.eepBuf[i] = 0xff;

      }

  //}

  //[ȿ ּ  ʱȭ]
  //{
      _AVR.eepWriteStartAdr = 0;

      _AVR.eepWriteEndAdr   = _AVR.eepSize - 1;

  //}

  return;

}

//------------------------------------------------------------------------------
//[System]----------------------------------------------------------------------
//------------------------------------------------------------------------------

void AVR_⵿(void)
{
  //[2009.12.01.ȭ][!!!]{---
  //AVR  [⵿] Ų.
  //}--------------------------

  _Spi_Ĩ_(_ispƮ, 1);

  ð_ms(2);

  _Spi_Ĩ_(_ispƮ, 0);

  ð_ms(40);

  _Spi_Ĩ_(_ispƮ, 1);

  ð_ms(2);

  return;

}

bool AVR_α׷_(void)
{
  //[2009.12.02.][!!!]{--------------------
  //AVR  [α׷]  ԽŰ  ȯѴ.
  //}------------------------------------------
  
  AVR_⵿();
 
  _Spi_Ĩ_(_ispƮ, 0);

  ð_ms(40);

  //[α׷  ]
  //{
      _Spi_Ʈ_(_ispƮ, 8, 0xac);
      _Spi_Ʈ_(_ispƮ, 8, 0x53);

      //[Ȯ]{--------------------------------------------------
      //[α׷]  ߴ Ȯϰ ȵȴٸ false  ȯѴ.
      if(_Spi_Ʈб_(_ispƮ, 8, 0x00) != 0x53) return(false);
      //}----------------------------------------------------------

      _Spi_Ʈ_(_ispƮ, 8, 0x00);

      ð_ms(2);

  //}

  return(true);

}

//------------------------------------------------------------------------------
//[Erase]-----------------------------------------------------------------------
//------------------------------------------------------------------------------

void AVR_ü_(void)
{
  //[2009.12.02.][!!!]{---------
  //AVR  Flash/EEprom   .
  // ǻ  .
  //}-------------------------------

  _Spi_Ʈ_(_ispƮ, 8, 0xac);
  _Spi_Ʈ_(_ispƮ, 8, 0x80);
  _Spi_Ʈ_(_ispƮ, 8, 0x00);
  _Spi_Ʈ_(_ispƮ, 8, 0x00);

  ð_ms(100);

  return;

}

//------------------------------------------------------------------------------
//[SignatureByte]---------------------------------------------------------------
//------------------------------------------------------------------------------

bool AVR_ȣ_Ȯ(void)
{
  //[2009.12.02.][!!!]{------------------------------
  //[ȣ]   ´ٸ true  Ʋٸ false  ȯѴ.
  //}----------------------------------------------------
  
  //[VAR]
  //{
      unsigned char  ȣ[3];

  //}

  //[ȣ б]
  //{
      //  [ȣ]  о δ.
      AVR_ȣ_б(ȣ);

  //}

  //[ȣ]
  //{
      if((_AVR.signatureByte[0] == ȣ[0]) &&
         (_AVR.signatureByte[1] == ȣ[1]) &&
         (_AVR.signatureByte[2] == ȣ[2]))
      {
        //[ȣ]  ġѴ.
        return(true);

      }
      else
      {
        //  ٸ ̴.
        return(false);
        
      }

  //}

}

void AVR_ȣ_б(unsigned char  *pȣ)
{
  //[2009.12.02.][!!!]{------------------------
  //[AVR]   ϴ [ȣ]  о鿩 ȯѴ.
  //3  ̹Ƿ 迭  ش. 
  //}-----------------------------------------------

  //[VAR]
  //{
      int count;

  //}
  
  for(count = 0; count < 3; count++)
  {
    _Spi_Ʈ_(_ispƮ, 8, 0x30);
    _Spi_Ʈ_(_ispƮ, 8, 0x00);
    _Spi_Ʈ_(_ispƮ, 8, count);

    pȣ[count] = _Spi_Ʈб_(_ispƮ, 8);
    
  }

  return;

}

//------------------------------------------------------------------------------
//[Fuse]------------------------------------------------------------------------
//------------------------------------------------------------------------------

void AVR_ǻ_Ʈ_(void)
{
  //[2009.12.02.][!!!]{---
  //fuse low byte  Ѵ.
  //}-------------------------

  START:

  _Spi_Ʈ_(_ispƮ, 8, 0xac);
  _Spi_Ʈ_(_ispƮ, 8, 0xa0);
  _Spi_Ʈ_(_ispƮ, 8, 0x00);
  _Spi_Ʈ_(_ispƮ, 8, _AVR.fuseLow);

  ð_ms(10);

  //[Ȯ]
  //{
      /*
      //ٽ о ġ ʴ  ٽ Ѵ.
      _Spi_Ʈ_(_ispƮ, 8, 0x50);
      _Spi_Ʈ_(_ispƮ, 8, 0x00);
      _Spi_Ʈ_(_ispƮ, 8, 0x00);

      if(_Spi_Ʈб_(_ispƮ, 8) != _AVR.fuseLow) goto START;
      */ 
  //}

  return;

}

void AVR_ǻ_Ʈ_б(void)
{
  //[2009.12.02.][!!!]{-------------------
  //fuse low byte  о [ü]  Ѵ.
  //}------------------------------------------

  _Spi_Ʈ_(_ispƮ, 8, 0x50);
  _Spi_Ʈ_(_ispƮ, 8, 0x00);
  _Spi_Ʈ_(_ispƮ, 8, 0x00);

  _AVR.fuseLow = _Spi_Ʈб_(_ispƮ, 8);

  return;

}

void AVR_ǻ_Ʈ_(void)
{
  //[2009.12.02.][!!!]{---
  //fuse high byte  Ѵ.
  //}-------------------------

  START:

  _Spi_Ʈ_(_ispƮ, 8, 0xac);
  _Spi_Ʈ_(_ispƮ, 8, 0xa8);
  _Spi_Ʈ_(_ispƮ, 8, 0x00);
  _Spi_Ʈ_(_ispƮ, 8, _AVR.fuseHigh);

  ð_ms(10);

  //[Ȯ]
  //{
      /*
      //ٽ о ġ ʴ  ٽ Ѵ.
      _Spi_Ʈ_(_ispƮ, 8, 0x58);
      _Spi_Ʈ_(_ispƮ, 8, 0x08);
      _Spi_Ʈ_(_ispƮ, 8, 0x00);

      if(_Spi_Ʈб_(_ispƮ, 8) != _AVR.fuseHigh) goto START;
      */

  //}

  return;

}

void AVR_ǻ_Ʈ_б(void)
{
  //[2009.12.02.][!!!]{--------
  //fuse high byte  о ȯѴ.
  //}------------------------------

  _Spi_Ʈ_(_ispƮ, 8, 0x58);
  _Spi_Ʈ_(_ispƮ, 8, 0x08);
  _Spi_Ʈ_(_ispƮ, 8, 0x00);

  _AVR.fuseHigh = _Spi_Ʈб_(_ispƮ, 8);

  return;

}

void AVR_ǻ_ȮƮ_(void)
{
  //[2009.12.02.][!!!]{---
  //Fuse Eext byte  Ѵ.
  //}-------------------------

  START:

  _Spi_Ʈ_(_ispƮ, 8, 0xac);
  _Spi_Ʈ_(_ispƮ, 8, 0xa4);
  _Spi_Ʈ_(_ispƮ, 8, 0x00);
  _Spi_Ʈ_(_ispƮ, 8, _AVR.fuseExt);

  ð_ms(10);

  //[Ȯ]
  //{
      /*
      //ٽ о ġ ʴ  ٽ Ѵ.
      _Spi_Ʈ_(_ispƮ, 8, 0x50);
      _Spi_Ʈ_(_ispƮ, 8, 0x08);
      _Spi_Ʈ_(_ispƮ, 8, 0x00);

      if(_Spi_Ʈб_(_ispƮ, 8) != _AVR.fuseExt) goto START;
      */

  //}

  return;

}

void AVR_ǻ_ȮƮ_б(void)
{
  //[2009.12.02.][!!!]{-------
  //Fuse Ext byte  о ȯѴ.
  //}-----------------------------

  _Spi_Ʈ_(_ispƮ, 8, 0x50);
  _Spi_Ʈ_(_ispƮ, 8, 0x08);
  _Spi_Ʈ_(_ispƮ, 8, 0x00);

  _AVR.fuseExt = _Spi_Ʈб_(_ispƮ, 8);

  return;

}

//------------------------------------------------------------------------------
//[Lock]------------------------------------------------------------------------
//------------------------------------------------------------------------------

void AVR__(void)
{
  //[2009.12.02.][!!!]{--
  //lock bit  Ѵ.
  //}------------------------

  START:

  _Spi_Ʈ_(_ispƮ, 8, 0xac);
  _Spi_Ʈ_(_ispƮ, 8, 0xe0);
  _Spi_Ʈ_(_ispƮ, 8, 0x00);
  _Spi_Ʈ_(_ispƮ, 8, _AVR.lockBit);

  ð_ms(10);

  //[Ȯ]
  //{
      //ٽ о ġ ʴ  ٽ Ѵ.
      _Spi_Ʈ_(_ispƮ, 8, 0x58);
      _Spi_Ʈ_(_ispƮ, 8, 0x00);
      _Spi_Ʈ_(_ispƮ, 8, 0x00);

      if(_Spi_Ʈб_(_ispƮ, 8) != _AVR.lockBit) goto START;

  //}

  return;

}

void AVR__б(void)
{
  //[2009.12.02.][!!!]{---
  //lock bit  о ȯѴ.
  //}-------------------------

  _Spi_Ʈ_(_ispƮ, 8, 0x58);
  _Spi_Ʈ_(_ispƮ, 8, 0x00);
  _Spi_Ʈ_(_ispƮ, 8, 0x00);

  _AVR.lockBit = _Spi_Ʈб_(_ispƮ, 8);

  return;

}

//------------------------------------------------------------------------------
//[Flash]-----------------------------------------------------------------------
//------------------------------------------------------------------------------

void AVR_Flash___ҿ_(unsigned int    pּ,
                                           unsigned short  p2Ʈ)
{
  //[2009.12.02.][!!!]{-----------------------------------------
  //Flash   page  AVR  <Page  >  Ѵ.
  //p2Ʈ  low->high Ʈ   ش.
  //page   ü  Ѵ.
  //AVR  Flash  1 Address  2 Ʈ ȴ.
  //
  //[!!!]---------------------------------------------------------
  //flashPageSize   2Ʈ  ǳ [ü]  Ʈ 
  //ϵ Ƿ ÿ 2Ʈ  ٲ ؾ Ѵ.
  //}----------------------------------------------------------------

  //[VAR]
  //{
      unsigned int   ּ߰Ҹũ;
      
      unsigned char  [8];

  //}

  //[ó]
  //{
      //[Page Bit Mask ϱ]{----------------------------------
      //[Page  ]  Page ũ ŭ Address  ؾ ϹǷ
      //̰͸ ɷ ü .
      // 64   -1   63  ü(0x3f) ȴ.
      ּ߰Ҹũ = (_AVR.flashPageSize / 2) - 1;
      //}-------------------------------------------------------

  //}
  
  //[ ڷ῭ ]
  //{
      //Ѳ Ͽ ð Ű Ͽ ϴ ҿ Ѵ.
      
      //[ Ʈ ]{------------------
      [0] = 0x40;
      [1] = 0x00;
      [2] = pּ & ּ߰Ҹũ;
      [3] = p2Ʈ & 0xff;
      //
      //[ Ʈ ]-------------------
      [4] = 0x48;
      [5] = 0x00;
      [6] = pּ & ּ߰Ҹũ;
      [7] = (p2Ʈ >> 8) & 0xff;
      //}---------------------------------
      
  //}
  
  //[Ѳ ]
  //{
      _Spi__(_ispƮ, , 8);
      
  //}    
  
  return;

}
         
void Flash__(unsigned int  pּ)
{
  //[2009.12.02.][!!!]{-------------------------------------------------
  //AVR  <Page >   ִ Page  Flash   Page  Ѵ.
  //page  [ü]  Ѵ.
  //AVR  Flash  1 Address  2 byte  ȴ.
  //
  // Page    ġϴ ˻ϰ ġ  ʴ´ٸ  ٽ Ѵ.
  //
  //[!!!]-----------------------------------------------------------------
  //flashPageSize   2Ʈ  ǳ  Ʈ  ϵ Ƿ 
  //ÿ 2Ʈ  ٲ ؾ Ѵ.
  //}------------------------------------------------------------------------

  //[VAR]
  //{
      unsigned int   ּҸũ;
      
      unsigned char  [4];

  //}

  //[ó]
  //{
      //[Page Bit Mask ϱ]{--------------------------------------------
      //Page Address  Page ũ ŭ Address   Ǿ ϹǷ ϰ
      //Page  Address  ɷټ ִ ü .
      // 64   -1   63    ü(0xffffffc0) ȴ.

      ּҸũ = ~((unsigned int)((_AVR.flashPageSize / 2) - 1));
      //}-----------------------------------------------------------------

  //}

  //[Page Address  ]{----------------------------------
  //64 word  write ϹǷ  6 bit address  mask Ѵ.
  pּ &= ּҸũ;
  //}------------------------------------------------------
  
  //[ ڷ῭ ]
  //{
      //Ѳ Ͽ ð Ű Ͽ ϴ ҿ Ѵ.
      
      [0] = 0x4c;

      // ּ.
      [1] = (pּ >> 8) & 0xff;

      // ּ.
      [2] = pּ & 0xff;

      [3] = 0x00;
      
  //}
  
  START:
  
  //[Ѳ ]
  //{
      _Spi__(_ispƮ, , 4);
      
  //}
  
  //ּ Ŵ  ð Ѵ.
  ð_ms(_AVR.flashPageWriteTime);

  // Page   ϵ  ġϴ Ȯϰ  ϵ ʾҴٸ ٽ Ѵ.
  if(AVR_Flash__Ȯ(pּ, pּ + (_AVR.flashPageSize / 2) - 1) != true) goto START;

  return;

}

bool AVR_Flash__Ȯ(unsigned int  pּ,
                         unsigned int  pּ)
{
  //[2009.12.02.][!!!]{---------------------------------------------
  // Page     ġϴ ȮѴ.
  // Լ Flash Page Write ÿ ϵ  Ȯϰ ġ  ʴ° ִ 
  //ٽ  ֱ Ͽ ʿϴ.
  //}-------------------------------------------------------------------

  //[VAR]
  //{
      unsigned int    ּ;
      unsigned short  ;

  //}

  for(ּ =  pּ;
      ּ <= pּ;
      ּ++)
  {
    //[!]{------------------------------------------------------
    //1 Address  2Ʈ  Ѵ.
    // ҿ ̹ 2Ʈ  ϹǷ ϰ    ִ.
    //}---------------------------------------------------------

    // ּ 2Ʈ  б.
     = AVR_Flash_б(ּ);

    //ġ ʴ  ִ   ˷ְ ⼭ Ѵ.
    if( != _AVR.flashBuf[ּ]) return(false);

  }

  //° ش Page    ġϴ ̴.
  return(true);

}

void AVR_Flash__۳ּ_(void)
{
  //[2009.12.02.][!!!]{--------------------------------------
  //ü  Ͽ  Page  / ּҸ ؼ [ü] 
  //ش  Ѵ.
  //
  //[!!!]------------------------------------------------------
  //flashPageSize   2Ʈ  ǳ  Ʈ 
  //ϵ Ƿ ÿ 2Ʈ  ٲ ؾ Ѵ.
  //}-------------------------------------------------------------

  //[VAR]
  //{
      unsigned int  ּҸũ;

  //}

  //[ó]
  //{
      //[Page Bit Mask ϱ]{--------------------------------------------
      //Page Address  Page ũ ŭ Address   Ǿ ϹǷ ϰ
      //Page  Address  ɷټ ִ ü .
      // 64   -1   63    ü(0xffffffc0) ȴ.
      ּҸũ = ~((unsigned int)((_AVR.flashPageSize / 2) - 1));
      //}-----------------------------------------------------------------

      //   Page ּҸ Ѵ(ּҰ  Page ȣ ȴ).
      _AVR.flashWritePageStartAdr = _AVR.flashWriteStartAdr & ּҸũ;

      //   Page ּҸ Ѵ(ּҰ  Page ȣ ȴ).
      _AVR.flashWritePageEndAdr   = _AVR.flashWriteEndAdr   & ּҸũ;

  //}

  return;

}
/*
void AVR_Flash_(void)
{
  //[2009.12.02.][!!!]{-------------------------------------------------
  //[ ּ] - [ ּ]  Flash ҿ   Page  Ѵ.
  //page ũ⿡    page ũ⿡ °  κ 0xff  äش.
  //Flash Ҵ  ޸𸮿  Ƿ ̰ Page ũ ŭ о Ѵ.
  //
  //[!!!]-----------------------------------------------------------------
  //flashPageSize   2Ʈ  ǳ  Ʈ  ϵ Ƿ
  //ÿ Ʈ  ٲ ؾ Ѵ.
  //}------------------------------------------------------------------------

  //[]{---------------------------------------------------------------------
  //  Page (Word )  Page Address(Page )  ˸  ϸ
  //Flash    Page ̹Ƿ   ߿ϴ.
  //StartAdr/EndAdr  ԵǴ Page  ׳ δ Ѵ.
  //׸   Verify  Ͽ [ü]   ´.
  //}--------------------------------------------------------------------------

  //[VAR]
  //{
      unsigned int  ּ߰;
      unsigned int  ּ; //Page ũ  Ѵ.

  //}

  //[ó]
  //{
      //  Page / ּҸ ´( ü  ).
      AVR_Flash__۳ּ_();

  //}

  //[]
  //{
      for(ּ =  _AVR.flashWritePageStartAdr;
          //  Page  ԵǾ Ѵ.
          ּ <= _AVR.flashWritePageEndAdr;
          //Page Address  Page ũ ŭ  Ų.
          ּ += (_AVR.flashPageSize / 2))
      {
        for(//Page  Address  ׻ 0   ۵ǹǷ 0  ʱȭ Ѵ.
            ּ߰ = 0;
            //Page ũ ŭ Ѵ.
            ּ߰ < (_AVR.flashPageSize / 2);
            ּ߰++)
        {
          //AVR Flash  1 Address  1word  ȴ.

          //[Page Buffer  ϱ]{----------------------------------------------------------
          //ۿ   ġ ȯϿ о Ѵ.----------------v
          AVR_Flash___ҿ_(ּ߰, _AVR.flashBuf[ּ + ּ߰]);
          //}--------------------------------------------------------------------------------

        }

        //[Page Buffer  ]{-----------------------
        //AVR   ۾   Flash  Ѵ.
        Flash__(ּ);
        //}--------------------------------------------
     
      }

  //}
   
  return;

}
*/
unsigned short AVR_Flash_б(unsigned int  pּ)
{
  //[2009.12.02.][!!!]{-----------------
  // Flash ּҿ 2Ʈ о ȯѴ.
  //}---------------------------------------

  //[VAR]
  //{
      unsigned short  ;
      
      unsigned char   [8], б[8];

  //}
  
  //[ʱȭ]
  //{
       = 0x000000;      
  
  //}
  
  //[ ڷ῭ ]
  //{
      //Ѳ Ͽ ð Ű Ͽ ϴ ҿ Ѵ.
      
      // Ʈ .
      [0] = 0x28;
      [1] = (pּ >> 8) & 0xff;
      [2] = pּ & 0xff;
      [3] = 0; //ǹ  (̺κ д κ̴).
 
      // Ʈ . 
      [4] = 0x20;
      [5] = (pּ >> 8) & 0xff;
      [6] = pּ & 0xff;
      [7] = 0; //ǹ  (̺κ д κ̴).
      
  //}
  
  //[Ѳ /б]
  //{
      //鼭 ÿ оδ.
      _Spi_б_(_ispƮ, , б, 8);
      
  //}    

  //[ ]
  //{
      // Ʈ.
       |= (((unsigned short)(б[3]) << 8) & 0xff00);
   
      // Ʈ.      
       |= (б[7] & 0xff);
  
  //}

  return( & 0xffff);

}
/*
bool AVR_Flash_Ȯ(unsigned int    *r߻ּ, // ߻ ּҰ.
                   unsigned short  *rѰ,    // ּҿ   .
                   unsigned short  *r)     // .
{
  //[2009.12.02.][!!!]{----------------------------------
  //Flash    AVR Flash   ġ ϴ ȮѴ.
  //Flash  1 Address  2Ʈ Ϳ  Ѵ.
  //[ü] ȿ   Ƿ    óѴ.
  //}--------------------------------------------------------

  //[VAR]
  //{
      unsigned int    ּ;
      unsigned short  ;

  //}

  for(ּ =  _AVR.flashWriteStartAdr;
      ּ <= _AVR.flashWriteEndAdr;
      ּ++)
  {
    //[!]{------------------------------------------------------
    //1 Address  2Ʈ  Ѵ.
    // ҿ ̹ 2Ʈ  ϹǷ ϰ    ִ.
    //}---------------------------------------------------------

    // ּ 2Ʈ  б.
     = AVR_Flash_б(ּ);

    if( != _AVR.flashBuf[ּ])
    {
      // ߻  [ּ/Ѱ/]  ȯѴ.

      (*r߻ּ) = ּ;
      (*rѰ)    = _AVR.flashBuf[ּ];
      (*r)      = ;
    
      return(false);

    }

  }

  return(true);

}
*/
void AVR_Flash_о鿩_ҿ_(void)
{
  //[2009.12.02.][!!!]{--------------------------
  //AVR   Flash   о 鿩 ҿ Ѵ.
  //}------------------------------------------------

  //[VAR]
  //{
      unsigned int  ּ;

  //}

  for(ּ =  0;
      ּ < (_AVR.flashSize / 2);
      ּ++)
  {
    //[!]{------------------------------
    //1ּ  2Ʈ  о 鿩 Ѵ.
    //}---------------------------------

    // ּ 2Ʈ  о .
    _AVR.flashBuf[ּ] = AVR_Flash_б(ּ);

  }

  return;

}

//------------------------------------------------------------------------------
//[Eeprom]----------------------------------------------------------------------
//------------------------------------------------------------------------------

void AVR_EEprom_Ʈ_(unsigned int   pּ,
                          unsigned char  pƮ)
{
  //[2009.12.02.][!!!]{--------------------------------
  //EEprom   ּҿ 1Ʈ Ѵ.
  //
  //׳ ð ϴ  û ̹Ƿ Ŵ    а
  //ġ ʴ  ٽ Ѵ.
  //}-------------------------------------------------------
  
  //[VAR]
  //{
      unsigned char  [4];
  
  //}
  
  //[ ڷ῭ ]
  //{
      //Ѳ Ͽ ð Ű Ͽ ϴ ҿ Ѵ.
      
      [0] = 0xc0;
      [1] = (pּ >> 8) & 0xff;
      [2] = pּ & 0xff;
      [3] = pƮ;
      
  //}
  
  START:
  
  //[Ѳ ]
  //{
      _Spi__(_ispƮ, , 4);
      
  //}

  //ϴ Ŵ ּ  ð Ѵ.
  ð_ms(_AVR.eepWriteTime);

  //о鿩   Ǿ Ȯϰ ġ ʴ´ٸ ٽ Ѵ.
  if(AVR_EEprom_Ʈ_б(pּ) != pƮ) goto START;

  return;

}

unsigned char AVR_EEprom_Ʈ_б(unsigned int  pּ)
{
  //[2009.12.02.][!!!]{-------------
  //EEprom   ּҿ 1Ʈ о´.
  //}-----------------------------------

  //[VAR]
  //{
      unsigned char   [4], б[4];

  //}
  
  //[ ڷ῭ ]
  //{
      //Ѳ Ͽ ð Ű Ͽ ϴ ҿ Ѵ.
      
      [0] = 0xa0;
      [1] = (pּ >> 8) & 0xff;
      [2] = pּ & 0xff;
      [3] = 0; //ǹ  ( д ġ).
      
  //}
  
  //[Ѳ /б]
  //{
      //鼭 ÿ оδ.
      _Spi_б_(_ispƮ, , б, 4);
      
  //}      

  return(б[3]);

}
/*
void AVR_EEprom_(void)
{
  //[2009.12.02.][!!!]{------------------
  //EEprom   EEprom   Ѵ.
  //}----------------------------------------

  //[VAR]
  //{
      unsigned int  i;

  //}

  for(i = _AVR.eepWriteStartAdr; i <= _AVR.eepWriteEndAdr; i++)
  {
    AVR_EEprom_Ʈ_(i, _AVR.eepBuf[i]);

  }
  
  return;

}
*/
/*
bool AVR_EEprom_Ȯ(unsigned int    *r߻ּ,
                    unsigned short  *rѰ,
                    unsigned short  *r)
{
  //[2009.12.02.][!!!]{------------------------------------
  //EEprom     EEprom   ġϴ ȮѴ.
  //[ü] ȿ   Ƿ    óѴ.
  //}----------------------------------------------------------

  //[VAR]
  //{
      unsigned int    ּ;
      unsigned char   ;

  //}

  for(ּ =  _AVR.eepWriteStartAdr;
      ּ <= _AVR.eepWriteEndAdr;
      ּ++)
  {
    // ּ Ʈ  б.
     = AVR_EEprom_Ʈ_б(ּ);

    if( != _AVR.eepBuf[ּ])
    {
      // ߻  [ּ/Ѱ/]  ȯѴ.

      (*r߻ּ)  = ּ;
      (*rѰ) = _AVR.eepBuf[ּ];
      (*r)  = ;

      return(false);

    }

  }

  return(true);

}
*/
void AVR_EEprom_о鿩_ҿ_(void)
{
  //[2009.12.02.][!!!]{---------------------------
  //AVR   EEprom   о 鿩 ҿ Ѵ.
  //}-------------------------------------------------

  //[VAR]
  //{
      unsigned int  ּ;

  //}

  for(ּ =  0;
      ּ < _AVR.eepSize;
      ּ++)
  {
    //[!]{------------------------------
    //1ּ  1Ʈ  о 鿩 Ѵ.
    //}---------------------------------

    // ּ Ʈ  о .
    _AVR.eepBuf[ּ] = AVR_EEprom_Ʈ_б(ּ);

  }

  return;

}














